/* 
 * File:   ADHEADER.h
 * Author: michael williams
 *
 * ADC code and functions
 */

#ifndef ADHEADER_H
#define	ADHEADER_H

#ifdef	__cplusplus
extern "C" {
#endif

/*FUNCTION PROTOTYPES*/
void ADC_init(void);
float ADC_read_temperature(void);
float ADC_read_test_strip(void);

/*FUNCTION DEFINITIONS*/
void ADC_init(void){
    AD1PCFGbits.PCFG4 = 0; //set pins as analog
    AD1PCFGbits.PCFG5 = 0; //set pins as analog
    AD1CON1bits.FORM = 0; //unsigned int
    AD1CON1bits.SSRC = 0; //set to manual conversion
    AD1CON2bits.VCFG = 0; //Use AVdd and AVss
    AD1CON2bits.CSCNA = 0; //Disable Scan Mode
    AD1CON2bits.BUFM = 0; //single 16 bit buffer
    AD1CON2bits.ALTS = 0; //Use mux a
    AD1CON3bits.ADRC = 0; //Use PB Bus Clock
    AD1CON3bits.ADCS = 3; //Math in word doc
    AD1CON1bits.ON = 1;

}

float ADC_read_temperature(void){
    float dig;
    float temp_C;
    float temp_F;

    AD1CHSbits.CH0SA = 4;

    AD1CON1bits.SAMP = 1;
    delay_us(100);
    AD1CON1bits.SAMP = 0;

    while(!AD1CON1bits.DONE);

    dig = (ADC1BUF0*3.300/1023); //scale
    temp_C = (dig - .50) / .010;
    temp_F = (temp_C * 9) / 5 + 32;

    AD1CHSbits.CH0SA = 5;

    AD1CON1bits.SAMP = 1;
    delay_us(100);
    AD1CON1bits.SAMP = 0;


    while(!AD1CON1bits.DONE);
    dig = (ADC1BUF0*3.300/1023); //scale

    return(temp_F);
}


float ADC_read_test_strip(void){
    float dig;

    //sets what channel we are reading from
    AD1CHSbits.CH0SA = 5;

    //tells us that we should start reading
    AD1CON1bits.SAMP = 1;
    delay_us(100);
    //tells us we are ready to convert
    AD1CON1bits.SAMP = 0;

    //done converting
    while(!AD1CON1bits.DONE);
    dig = (ADC1BUF0*3.300/1023); //scale

    return(dig);
}


#ifdef	__cplusplus
}
#endif

#endif	/* ADHEADER_H */

