/* 
 * File:   Button.h
 * Author: mwilli31
 *
 * Created on April 2, 2015, 12:49 AM
 */

#ifndef BUTTON_H
#define	BUTTON_H

#ifdef	__cplusplus
extern "C" {
#endif

/*FUNCTION PROTOTYPES*/
void button_init(void);
void button_1_init(void);
void button_2_init(void);
int button_pressed(void);

/*FUNCTION DEFINITIONS*/
void button_init(void){
    AD1PCFGbits.PCFG6 = 1;
    TRISBbits.TRISB6 = 1;
}

void button_1_init(void){
    TRISDbits.TRISD9 = 1;
    
    IEC0bits.INT2IE = 0;    //disable interrupt routine

    INTCONbits.INT2EP = 0;  //falling edge triggered
    IFS0bits.INT2IF = 0;    //reset interrupt flag
    IPC2bits.INT2IP = 7;    //set priority

    IEC0bits.INT2IE = 1;    //enable interrupt routine
    
}

void button_2_init(void) {
    TRISDbits.TRISD11 = 1;

    IEC0bits.INT4IE = 0;    //disable interrupt routine

    INTCONbits.INT4EP = 0;  //falling edge triggered
    IFS0bits.INT4IF = 0;    //reset interrupt flag
    IPC4bits.INT4IP = 7;    //set priority
    IEC0bits.INT4IE = 1;    //enable interrupt routine
}

int button_pressed(void) {
    int b;
    b = PORTDbits.RD9;
    delay_ms(100);
    return b;
}


#ifdef	__cplusplus
}
#endif

#endif	/* BUTTON_H */

