#include "Timer.h"
#include <xc.h>
#include <sys/attribs.h>
#include "SDlib.h"
#include <time.h>

void __ISR(_TIMER_3_VECTOR, IPL7AUTO) clockTimer(void)
{
    if(IFS0bits.T3IF == 1) {
        IFS0bits.T3IF = 0;    //reset interrupt flag
        update_current_time();
    } else {
        //do nothing
    }
}

/*FUNCTION DEFINITIONS*/
void timer_start(void){
    T2CONbits.ON = 0;
    

    T2CONbits.TCKPS0 = 1;
    T2CONbits.TCKPS1 = 1;
    T2CONbits.TCKPS2 = 1;

    TMR2 = 0;
    PR2 = 0x9897;

    T2CONbits.ON = 1;
}

void timer_clk_start(void){
    IEC0bits.T3IE = 0;    //disable interrupt routine

    IFS0bits.T3IF = 0;    //reset interrupt flag
    IPC3bits.T3IP = 7;    //set priority

    IEC0bits.T3IE = 1;    //enable interrupt routine

    T3CONbits.ON = 0;
    T3CONbits.SIDL = 0; //continue in idle

    T3CONbits.TCKPS0 = 1;
    T3CONbits.TCKPS1 = 1;
    T3CONbits.TCKPS2 = 1;

    TMR3 = 0;
    //PR3 = 0x23C364;  //60 seconds
    PR3 = 0x5F5E6;

    T3CONbits.ON = 1;
}

void update_current_time(void) {
     current_time += 60;
     get_current_time();
}

unsigned int get_current_time(void) {
    /*struct tm  ts;
    char       buf[80];
    // Get current time
    
    // Format time, "ddd yyyy-mm-dd hh:mm:ss zzz"
    ts = *localtime((time_t)current_time);
    strftime(buf, sizeof(buf), "%a %Y-%m-%d %H:%M:%S %Z", &ts);
    */
    //OledClearBuffer();
    //OledSetCursor(0,0);
    //OledPutString("time");

    return 0;
}

int timeout(int time, int *counter, int *countdown) {
    if(IFS0bits.T2IF == 1) {
        *counter += 1;
    if(*counter == time){
        if(*countdown == -1) {
            return 0;
        } else if(*countdown == 0) {
                *countdown = 3;
                OledClearBuffer();
                OledSetCursor(0,0);
                OledPutString("turning off, goodbye");
                delay_ms(2000);
                return 0;
            }
            *counter = time - 1;
            OledClearBuffer();
            OledSetCursor(0,0);
            OledPutString("GOING");
            OledSetCursor(0,1);
            OledPutString("TO");
            OledSetCursor(0,2);
            OledPutString("SLEEP");
            OledSetCursor(0,3);
            OledPutString("IN");

            lcd_countdown(*countdown);

            *countdown -= 1;
        }
        IFS0bits.T2IF = 0;
    }
    
    return 1;
}

