/* spi init and other things */
#include <xc.h>
#include "../SDlib.h"  // for the pb clock
#include "NRFspi.h"

void NRFspi_init(unsigned long rate)
{
    /* make everything digital and useable */
  AD1PCFG = 0xFFFF; // all port pins digital
  DDPCONbits.JTAGEN = 0;
  U1CONbits.USBEN = 0;

  SPI4CONbits.ON = 0;
  SPI4CONbits.CKP = 0; // nrf is mode 0
  SPI4CONbits.CKE = 1;
  SPI4CONbits.SMP = 0;
  SPI4CONbits.MSTEN = 1; // master mode
  SPI4BRG = get_pb_clock() / 2 / rate - 1; // should be 100 KHz
  SPI4STATbits.SPIROV = 0; // clear any overflow?
  SPI4CONbits.ON = 1; // enable it now
  /* chip select stuff*/
  LATBbits.LATB8 = 1;
  TRISBbits.TRISB8 = 0; // set select output
  TRISBbits.TRISB12 = 0;  // nrf reset is output
}
/* function to send ang get back a byte on spi*/
unsigned char NRFspi_xcng(unsigned char data)
{
  NRFspi_int = 0;
  SPI4BUF = data;
  while (!NRFspi_int); // wait for int to read buffer
  return SPI4BUF;
}
