////
////  ble_transfer.c
////
////
////  Created by Christopher Homa on 2/19/15.
////
////
//
///* Copyright (c) 2014, Nordic Semiconductor ASA
// *
// * Permission is hereby granted, free of charge, to any person obtaining a copy
// * of this software and associated documentation files (the "Software"), to deal
// * in the Software without restariction, including without limitation the rights
// * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// * copies of the Software, and to permit persons to whom the Software is
// * furnished to do so, subject to the following conditions:
// *
// * The above copyright notice and this permission notice shall be included in all
// * copies or substantial portions of the Software.
// *
// * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// * SOFTWARE.
// */
//
//
///** @defgroup ble_uart_project_template ble_uart_project_template
//  @{
// @ingroup projects
// @brief Empty project that can be used as a template for new projects.
//
// @details
// This project is a firmware template for new projects.
// The project will run correctly in its current state.
// It can send data on the UART TX characteristic
// It can receive data on the UART RX characteristic.
// With this project you have a starting point for adding your own application functionality.
//
// The following instructions describe the steps to be made on the Windows PC:
//
// -# Install the Master Control Panel on your computer. Connect the Master Emulator
// (nRF2739) and make sure the hardware drivers are installed.
//
// -# You can use the nRF UART app in the Apple iOS app store and Google Play for Android 4.3 for Samsung Galaxy S4
// with this UART template app
//
// -# You can send data from the Arduino serial monitor, maximum length of a string is 19 bytes
// Set the line ending to "Newline" in the Serial monitor (The newline is also sent over the air
//
// *
// * Click on the "Serial Monitor" button on the Arduino IDE to reset the Arduino and start the application.
// * The setup() function is called first and is called only once for each reset of the Arduino.
// * The loop() function as the name implies is called in a loop.
// *
// * The setup() and loop() function are called in this way.
// * main()
// *  {
// *   setup();
// *   while(1)
// *   {
// *     loop();
// *   }
// * }
// *
// */
//#include <xc.h>
//#include "../configbitsrev2014vC-int.h"
//#include "./NRFspi.h"
//#include "../SDlib.h"
//#include "lib_aci.h"
//#include "aci_setup.h"
//#include "uart_over_ble.h"
//
//
///**
// Put the nRF8001 setup in the RAM of the nRF8001.
// */
//#include "services.h"
///**
// Include the services_lock.h to put the setup in the OTP memory of the nRF8001.
// This would mean that the setup cannot be changed once put in.
// However this removes the need to do the setup of the nRF8001 on every reset.
// */
//
//
//#ifdef SERVICES_PIPE_TYPE_MAPPING_CONTENT
//static services_pipe_type_mapping_t
//services_pipe_type_mapping[NUMBER_OF_PIPES] = SERVICES_PIPE_TYPE_MAPPING_CONTENT;
//#else
//#define NUMBER_OF_PIPES 0
//static services_pipe_type_mapping_t * services_pipe_type_mapping = NULL;
//#endif
//
/////* Store the setup for the nRF8001 in the flash of the AVR to save on RAM */
//static hal_aci_data_t setup_msgs[NB_SETUP_MESSAGES]  = SETUP_MESSAGES_CONTENT;
//
//// aci_struct that will contain
//// total initial credits
//// current credit
//// current state of the aci (setup/standby/active/sleep)
//// open remote pipe pending
//// close remote pipe pending
//// Current pipe available bitmap
//// Current pipe closed bitmap
//// Current connection interval, slave latency and link supervision timeout
//// Current State of the the GATT client (Service Discovery)
//// Status of the bond (R) Peer address
//static struct aci_state_t aci_state;
//
///*
// Temporary buffers for sending ACI commands
// */
//static hal_aci_evt_t  aci_data;
////static hal_aci_data_t aci_cmd;
//
///*
// Timing change state variable
// */
//static bool timing_change_done          = false;
//
///*
// Used to test the UART TX characteristic notification
// */
//static uart_over_ble_t uart_over_ble;
//static uint8_t         uart_buffer[20];
//static uint8_t         uart_buffer_len = 0;
//static uint8_t         dummychar = 0;
//
//bool connected = false;
///*
// Initialize the radio_ack. This is the ack received for every transmitted packet.
// */
////static bool radio_ack_pending = false;
//
///* Define how assert should function in the BLE library */
//void __ble_assert(const char *file, uint16_t line)
//{
//    //  Serial.print("ERROR ");
//    //  Serial.print(file);
//    //  Serial.print(": ");
//    //  Serial.print(line);
//    //  Serial.print("\n");
//    while(1);
//}
///*
// Description:
//
// In this template we are using the BTLE as a UART and can send and receive packets.
// The maximum size of a packet is 20 bytes.
// When a command it received a response(s) are transmitted back.
// Since the response is done using a Notification the peer must have opened it(subscribed to it) before any packet is transmitted.
// The pipe for the UART_TX becomes available once the peer opens it.
// See section 20.4.1 -> Opening a Transmit pipe
// In the master control panel, clicking Enable Services will open all the pipes on the nRF8001.
//
// The ACI Evt Data Credit provides the radio level ack of a transmitted packet.
// */
///* protos*/
//void setup(void);
//int loop(int verification);
//
//
//int sendCount = 0;
//void main(void)
//{
//    int verification = 0;
//    setup();
//    int sendCount = 0;
//    while(1){
//        sendCount = loop(sendCount);
//    }
//}
//
//
//
//void setup (void)
//{
//    serial_init(57600);
//    //  //Wait until the serial port is available (useful only for the Leonardo)
//    //  //As the Leonardo board is not reseted every time you open the Serial Monitor
//    //  #if defined (__AVR_ATmega32U4__)
//    //    while(!Serial)
//    //    {}
//    //    delay(5000);  //5 seconds delay for enabling to see the start up comments on the serial board
//    //  #elif defined(__PIC32MX__)
//    //    delay(1000);
//    //  #endif
//
//    //  Serial.println(F("Arduino setup"));
//    //  Serial.println(F("Set line ending to newline to send data from the serial monitor"));
//
//    printf("there was a print here\r\n");
//
//    /* setup toggles on f0 and f1*/
//    TRISFbits.TRISF0 = 0;
//    TRISFbits.TRISF1 = 0;
//#define blue LATFbits.LATF0 = 1; Nop(); LATFbits.LATF0 = 0;
//#define vio LATFbits.LATF1 = 1; Nop(); LATFbits.LATF1 = 0;
//
//
//    /**
//     Point ACI data structures to the the setup data that the nRFgo studio generated for the nRF8001
//     */
//    if (NULL != services_pipe_type_mapping)
//    {
//        aci_state.aci_setup_info.services_pipe_type_mapping = &services_pipe_type_mapping[0];
//    }
//    else
//    {
//        aci_state.aci_setup_info.services_pipe_type_mapping = NULL;
//    }
//    aci_state.aci_setup_info.number_of_pipes    = NUMBER_OF_PIPES;
//    aci_state.aci_setup_info.setup_msgs         = setup_msgs;  //????????
//    aci_state.aci_setup_info.num_setup_msgs     = NB_SETUP_MESSAGES;
//
//    /*
//     Tell the ACI library, the MCU to nRF8001 pin connections.
//     The Active pin is optional and can be marked UNUSED
//     */
//
//    aci_state.aci_pins.board_name = BOARD_DEFAULT; //See board.h for details REDBEARLAB_SHIELD_V1_1 or BOARD_DEFAULT
//    aci_state.aci_pins.reqn_pin   = LATBbits.LATB8; //SPI chip select
//    aci_state.aci_pins.rdyn_pin   = PORTDbits.RD0; //ready sig (also int!!)
//
//    /* SPI hadled in hardware*/
//    //  aci_state.aci_pins.mosi_pin   = MOSI;
//    //  aci_state.aci_pins.miso_pin   = MISO;
//    //  aci_state.aci_pins.sck_pin    = SCK;
//    //
//    //  aci_state.aci_pins.spi_clock_divider      = SPI_CLOCK_DIV8;//SPI_CLOCK_DIV8  = 2MHz SPI speed
//    //                                                             //SPI_CLOCK_DIV16 = 1MHz SPI speed
//    //
//    NRFspi_init(2000000ul);
//
//    aci_state.aci_pins.reset_pin              = LATBbits.LATB12; //4 for Nordic board, UNUSED for REDBEARLAB_SHIELD_V1_1
//    aci_state.aci_pins.active_pin             = LATBbits.LATB11;  // siad unused
//    aci_state.aci_pins.optional_chip_sel_pin  = UNUSED;
//
//    aci_state.aci_pins.interface_is_interrupt = false; //Interrupts still not available in Chipkit
//    aci_state.aci_pins.interrupt_number       = 1;
//
//    //We reset the nRF8001 here by toggling the RESET line connected to the nRF8001
//    //If the RESET line is not available we call the ACI Radio Reset to soft reset the nRF8001
//    //then we initialize the data structures required to setup the nRF8001
//    //The second parameter is for turning debug printing on for the ACI Commands and Events so they be printed on the Serial
//    lib_aci_init(&aci_state, false);
//    printf("Setup done\r\n");
//    blue
//}
//
//void uart_over_ble_init(void)
//{
//    uart_over_ble.uart_rts_local = true;
//}
//
//bool uart_tx(uint8_t *buffer, uint8_t buffer_len)
//{
//    bool status = false;
//
//    if (lib_aci_is_pipe_available(&aci_state, PIPE_UART_OVER_BTLE_UART_TX_TX) &&
//        (aci_state.data_credit_available >= 1))
//    {
//        status = lib_aci_send_data(PIPE_UART_OVER_BTLE_UART_TX_TX, buffer, buffer_len);
//        if (status)
//        {
//            aci_state.data_credit_available--;
//        }
//    }
//
//    return status;
//}
//
//bool uart_process_control_point_rx(uint8_t *byte, uint8_t length)
//{
//    bool status = false;
//    aci_ll_conn_params_t *conn_params;
//
//    if (lib_aci_is_pipe_available(&aci_state, PIPE_UART_OVER_BTLE_UART_CONTROL_POINT_TX) )
//    {
//        //  Serial.println(*byte, HEX);
//        printf("%x\r\n", *byte);
//        switch(*byte)
//        {
//                /*
//                 Queues a ACI Disconnect to the nRF8001 when this packet is received.
//                 May cause some of the UART packets being sent to be dropped
//                 */
//            case UART_OVER_BLE_DISCONNECT:
//                /*
//                 Parameters:
//                 None
//                 */
//                lib_aci_disconnect(&aci_state, ACI_REASON_TERMINATE);
//                status = true;
//                break;
//
//
//                /*
//                 Queues an ACI Change Timing to the nRF8001
//                 */
//            case UART_OVER_BLE_LINK_TIMING_REQ:
//                /*
//                 Parameters:
//                 Connection interval min: 2 bytes
//                 Connection interval max: 2 bytes
//                 Slave latency:           2 bytes
//                 Timeout:                 2 bytes
//                 Same format as Peripheral Preferred Connection Parameters (See nRFgo studio -> nRF8001 Configuration -> GAP Settings
//                 Refer to the ACI Change Timing Request in the nRF8001 Product Specifications
//                 */
//                conn_params = (aci_ll_conn_params_t *)(byte+1);
//                lib_aci_change_timing( conn_params->min_conn_interval,
//                                      conn_params->max_conn_interval,
//                                      conn_params->slave_latency,
//                                      conn_params->timeout_mult);
//                status = true;
//                break;
//
//                /*
//                 Clears the RTS of the UART over BLE
//                 */
//            case UART_OVER_BLE_TRANSMIT_STOP:
//                /*
//                 Parameters:
//                 None
//                 */
//                uart_over_ble.uart_rts_local = false;
//                status = true;
//                break;
//
//
//                /*
//                 Set the RTS of the UART over BLE
//                 */
//            case UART_OVER_BLE_TRANSMIT_OK:
//                /*
//                 Parameters:
//                 None
//                 */
//                uart_over_ble.uart_rts_local = true;
//                status = true;
//                break;
//        }
//    }
//
//    return status;
//}
//
//void aci_loop()
//{
//    static bool setup_required = false;
//
//    // We enter the if statement only when there is a ACI event available to be processed
//    if (lib_aci_event_get(&aci_state, &aci_data))
//    {
//        aci_evt_t * aci_evt;
//        aci_evt = &aci_data.evt;
//        switch(aci_evt->evt_opcode)
//        {
//                /**
//                 As soon as you reset the nRF8001 you will get an ACI Device Started Event
//                 */
//            case ACI_EVT_DEVICE_STARTED:
//            {
//                aci_state.data_credit_total = aci_evt->params.device_started.credit_available;
//                switch(aci_evt->params.device_started.device_mode)
//                {
//                    case ACI_DEVICE_SETUP:
//                        /**
//                         When the device is in the setup mode
//                         */
//                        printf("Evt Device Started: Setup\r\n");
//                        setup_required = true;
//                        break;
//
//                    case ACI_DEVICE_STANDBY:
//                        printf("Evt Device Started: Standby\r\n");
//                        //Looking for an iPhone by sending radio advertisements
//                        //When an iPhone connects to us we will get an ACI_EVT_CONNECTED event from the nRF8001
//                        if (aci_evt->params.device_started.hw_error)
//                        {
//                            delay_ms(20); //Handle the HW error event correctly.
//                        }
//                        else
//                        {
//                            lib_aci_connect(0/* in seconds : 0 means forever */, 0x0050 /* advertising interval 50ms*/);
//                            printf("Advertising started : Tap Connect on the nRF UART app\r\n");
//                        }
//
//                        break;
//                }
//            }
//                break; //ACI Device Started Event
//
//            case ACI_EVT_CMD_RSP:
//                //If an ACI command response event comes with an error -> stop
//                if (ACI_STATUS_SUCCESS != aci_evt->params.cmd_rsp.cmd_status)
//                {
//                    //ACI ReadDynamicData and ACI WriteDynamicData will have status codes of
//                    //TRANSACTION_CONTINUE and TRANSACTION_COMPLETE
//                    //all other ACI commands will have status code of ACI_STATUS_SCUCCESS for a successful command
//                    //          Serial.print(F("ACI Command "));
//                    //          Serial.println(aci_evt->params.cmd_rsp.cmd_opcode, HEX);
//                    //          Serial.print(F("Evt Cmd respone: Status "));
//                    //          Serial.println(aci_evt->params.cmd_rsp.cmd_status, HEX);
//
//                    printf("ACI Command ");
//                    printf("%x\r\n",aci_evt->params.cmd_rsp.cmd_opcode);
//                    printf("Evt Cmd respone: Status ");
//                    printf("%x\r\n",aci_evt->params.cmd_rsp.cmd_status);
//                }
//                if (ACI_CMD_GET_DEVICE_VERSION == aci_evt->params.cmd_rsp.cmd_opcode)
//                {
//                    //Store the version and configuration information of the nRF8001 in the Hardware Revision String Characteristic
//                    lib_aci_set_local_data(&aci_state, PIPE_DEVICE_INFORMATION_HARDWARE_REVISION_STRING_SET,
//                                           (uint8_t *)&(aci_evt->params.cmd_rsp.params.get_device_version), sizeof(aci_evt_cmd_rsp_params_get_device_version_t));
//                }
//                break;
//
//            case ACI_EVT_CONNECTED:
//                printf("Evt Connected");
//                connected = true;
//                sendCount = 0;
//                uart_over_ble_init();
//                timing_change_done              = false;
//                aci_state.data_credit_available = aci_state.data_credit_total;
//
//                /*
//                 Get the device version of the nRF8001 and store it in the Hardware Revision String
//                 */
//                lib_aci_device_version();
//                break;
//
//            case ACI_EVT_PIPE_STATUS:
//                printf("Evt Pipe Status");
//                if (lib_aci_is_pipe_available(&aci_state, PIPE_UART_OVER_BTLE_UART_TX_TX) && (false == timing_change_done))
//                {
////                    lib_aci_change_timing_GAP_PPCP(); // change the timing on the link as specified in the nRFgo studio -> nRF8001 conf. -> GAP.
//                    // Used to increase or decrease bandwidth
////                    timing_change_done = true;
//
////                    char pinPrompt[]="Please send Pin";
////                    uart_tx((uint8_t *)&pinPrompt[0], strlen(pinPrompt));
//                }
//                break;
//
//            case ACI_EVT_TIMING:
//                printf("Evt link connection interval changed");
//                lib_aci_set_local_data(&aci_state,
//                                       PIPE_UART_OVER_BTLE_UART_LINK_TIMING_CURRENT_SET,
//                                       (uint8_t *)&(aci_evt->params.timing.conn_rf_interval), /* Byte aligned */
//                                       PIPE_UART_OVER_BTLE_UART_LINK_TIMING_CURRENT_SET_MAX_SIZE);
//                break;
//
//            case ACI_EVT_DISCONNECTED:
//                printf("Evt Disconnected/Advertising timed out\r\n");
//                lib_aci_connect(0/* in seconds  : 0 means forever */, 0x0050 /* advertising interval 50ms*/);
//                printf("Advertising started. Tap Connect on the nRF UART app\r\n");
//                break;
//
//            case ACI_EVT_DATA_RECEIVED:
//                printf("Pipe Number: ");
//                printf("%d\r\n",aci_evt->params.data_received.rx_data.pipe_number);
//
//                if (PIPE_UART_OVER_BTLE_UART_RX_RX == aci_evt->params.data_received.rx_data.pipe_number)
//                {
//
//                    printf(" Data(Hex) : ");
//                    int i;
//                    for(i=0; i<aci_evt->len - 2; i++)
//                    {
//                        printf("%X ",(char)aci_evt->params.data_received.rx_data.aci_data[i]);
//                        uart_buffer[i] = aci_evt->params.data_received.rx_data.aci_data[i];
//                        // Serial.print(F(" "));
//                    }
//                    uart_buffer_len = aci_evt->len - 2;
//                    // Serial.println(F(""));
//                    if (lib_aci_is_pipe_available(&aci_state, PIPE_UART_OVER_BTLE_UART_TX_TX))
//                    {
////                       uint8_t pinPrompt[] = ;
////                       pinPrompt = uart_buffer;
//                        uart_tx((uint8_t *)&uart_buffer[0], strlen(uart_buffer));
//                        int stringIndex;
//                        for (stringIndex = 0; stringIndex < 20; stringIndex++)
//                        {
//                            uart_buffer[stringIndex] = ' ';
//                        }
//                    }
//                }
//                if (PIPE_UART_OVER_BTLE_UART_CONTROL_POINT_RX == aci_evt->params.data_received.rx_data.pipe_number)
//                {
//                    uart_process_control_point_rx(&aci_evt->params.data_received.rx_data.aci_data[0], aci_evt->len - 2); //Subtract for Opcode and Pipe number
//                }
//                break;
//
//            case ACI_EVT_DATA_CREDIT:
//                aci_state.data_credit_available = aci_state.data_credit_available + aci_evt->params.data_credit.credit;
//                break;
//
//            case ACI_EVT_PIPE_ERROR:
//                //See the appendix in the nRF8001 Product Specication for details on the error codes
//                printf("ACI Evt Pipe Error: Pipe #:");
//                printf("%d\r\n",aci_evt->params.pipe_error.pipe_number);
//                printf("  Pipe Error Code: 0x");
//                printf("%x \r\n",aci_evt->params.pipe_error.error_code);
//
//                //Increment the credit available as the data packet was not sent.
//                //The pipe error also represents the Attribute protocol Error Response sent from the peer and that should not be counted
//                //for the credit.
//                if (ACI_STATUS_ERROR_PEER_ATT_ERROR != aci_evt->params.pipe_error.error_code)
//                {
//                    aci_state.data_credit_available++;
//                }
//                break;
//
//            case ACI_EVT_HW_ERROR:
//                printf("HW error: ");
//                printf("%d \r\n",aci_evt->params.hw_error.line_num);
//
//                uint8_t counter;
//                for(counter = 0; counter <= (aci_evt->len - 3); counter++)
//                {
//                    printf("%d ", aci_evt->params.hw_error.file_name[counter]); //uint8_t file_name[20];  //was a arduino write???
//                }
//                printf("\r\n");
//                lib_aci_connect(0/* in seconds, 0 means forever */, 0x0050 /* advertising interval 50ms*/);
//                printf("Advertising started. Tap Connect on the nRF UART app");
//                break;
//
//        }
//    }
//    else
//    {
//    }
//
//    /* setup_required is set to true when the device starts up and enters setup mode.
//     * It indicates that do_aci_setup() should be called. The flag should be cleared if
//     * do_aci_setup() returns ACI_STATUS_TRANSACTION_COMPLETE.
//     */
//    if(setup_required)
//    {
//        if (SETUP_SUCCESS == do_aci_setup(&aci_state))
//        {
//            setup_required = false;
//            vio
//        }
//    }
//}
//
//bool stringComplete = false;  // whether the string is complete
//uint8_t stringIndex = 0;      //Initialize the index to store incoming chars
//
//void serialEvent(void);  // prototype for fnc below
//
//uint8_t data[5][20] = {100, 200, 150, 55, 60};
//
//int loop(int sendCount)
//{
//    //Process any ACI commands or events
//    aci_loop();
////    bool check = false;
////    if (connected)
////    {
////        while (sendCount < 6)
////        {
////            if (lib_aci_is_pipe_available(&aci_state, PIPE_UART_OVER_BTLE_UART_TX_TX))
////            {
////    //            if (verification == 0)
////    //            {
////    //                char send[] = "please enter pin: ";
////    //                uart_tx((uint8_t *)&send, strlen(send));
////    //            }
////    //            else
////    //            {
////                    printf("%i",sendCount);
////                    char send[] = "send";
////                    uart_tx((uint8_t *)&send, strlen(send));
////                    delay_ms(1000);
////                    sendCount = sendCount+1;
////                    delay_ms(1000);
////    //            }
////            }
////            else
////                break;
////
////
////        }
////        if (sendCount == 6)
////        {
////             lib_aci_disconnect(&aci_state, ACI_REASON_TERMINATE);
////        }
////        {
////            printf("disconnect");
////            ;
////        }
//
////    uint8_t pin = 111;
//
//
//
////    if (verification == false)
////        {
////            if (*uart_buffer == pin)
//////            if (c == 1)
////            {
////                verification = true;
//////                if (lib_aci_is_pipe_available(&aci_state, PIPE_UART_OVER_BTLE_UART_TX_TX))
//////                {
////                    char pinPrompt[]="Verified";
////                    uart_tx((uint8_t *)&pinPrompt[0], strlen(pinPrompt));
//////                }
////            }
//////            else
//////            {
//////            }
////
////        }
//
////    char pinPrompt[]="Verified";
////    uart_tx((uint8_t *)&pinPrompt[0], strlen(pinPrompt));
//    // print the string when a newline arrives:
//    if (stringComplete)
//    {
////        char str[strlen(stringComplete)];
////        atoi(pin, str, 10);
//
//        printf("Sending: ");
//        printf("%c \r\n",(char *)&uart_buffer[0]);
//
//        uart_buffer_len = stringIndex + 1;
//
//        if (!lib_aci_send_data(PIPE_UART_OVER_BTLE_UART_TX_TX, uart_buffer, uart_buffer_len))
//        {
//            printf("Serial input dropped\r\n");
//        }
//
//        // clear the uart_buffer:
//        for (stringIndex = 0; stringIndex < 20; stringIndex++)
//        {
//            uart_buffer[stringIndex] = ' ';
//        }
//
//        // reset the flag and the index in order to receive more data
//        stringIndex    = 0;
//        stringComplete = false;
//
//    }
//
//
//#if defined (__PIC32MX__)
//    if (U6STAbits.URXDA)
//    {
//        serialEvent();
//    }
//#endif
//
//    return sendCount;
//}
//
///*
// COMMENT ONLY FOR ARDUINO
// SerialEvent occurs whenever a new data comes in the
// hardware serial RX.  This routine is run between each
// time loop() runs, so using delay inside loop can delay
// response.  Multiple bytes of data may be available.
// Serial Event is NOT compatible with Leonardo, Micro, Esplora
// */
//void serialEvent(void) {
//
//    while(U6STAbits.URXDA){
//        // get the new byte:
//        dummychar = (uint8_t)getu();
//        if(!stringComplete)
//        {
//            if (dummychar == '\n')
//            {
//                // if the incoming character is a newline, set a flag
//                // so the main loop can do something about it
//                stringIndex--;
//                stringComplete = true;
//            }
//            else
//            {
//                if(stringIndex > 19)
//                {
//                    printf("Serial input truncated\r\n");
//                    stringIndex--;
//                    stringComplete = true;
//                }
//                else
//                {
//                    // add it to the uart_buffer
//                    uart_buffer[stringIndex] = dummychar;
//                    stringIndex++;
//                }
//            }
//        }
//    }
//}
