///*
// * File:   eeprom.h
// * Author: choma
// *
// * Created on March 31, 2015, 8:47 PM
// */
//
//#ifndef EEPROM_H
//#define	EEPROM_H
//
//#include "xc.h"
//#include <stdio.h>
//#include "../SDlib.h"
//#include "../configbitsrev2014vC-int.h"
//
//void I2C_init(void);
//void start(void);
//void restart(void);
//char I2C_send(char data);
//char I2C_write(char data);
//char I2C_receive(char ack);
//char I2C_read(void);
//
//
///*
// *
// */
////int main(int argc, char** argv) {
////
////
////    init();
////    I2C_write(0xAA); //Write AA
////    I2C_read(); //Read AA
////
////
////    return (EXIT_SUCCESS);
////}
//
//void eeprom_read(unsigned char dataOut)
//{
//    unsigned int Data;
//    Data = SPItransfer(0xFF);
//    Data = SPItransfer(0xFF);
//    Data = SPItransfer();
//}
//
//   void SPIbegin(void);
//   unsigned int SPItransfer(unsigned int dataOUT);
//
//	/*FUNCTION DEFINITIONS*/
//void SPIbegin(void)
//{
//    unsigned int rData;
//    IEC0CLR=0x03800000;	//disable all interrupts
//    SPI4CON = 0; // Stops and resets the SPI1.
//    rData=SPI4BUF; // clears the receive buffer
//    SPI4BRG=4; // needs to be 4 so SPI clock will run at 2MHz (fPB/(2(SPI4BRG+1))=2)
//    SPI4CONbits.CKE=1;// changed from 1 to 0?
//    SPI4CONbits.CKP=0;
//    SPI4CONbits.SMP=1; // right per Colin and Billy
//    SPI4CONbits.MSTEN=1; // make sure the SPI is in master mode
//    SPI4STATbits.SPIROV=0; // clear the overflow bit
//    SPI4CONbits.ON=1; // need to turn it on before initializing the EEPROM otherwise things get	reset
//
//
//    /*Initializes the FLASH?*/
//    DDPCONbits.JTAGEN=0; // turns off the JTAG
//    AD1PCFGbits.PCFG8=1; // Makes these bits be digital instead of analog outputs
//    AD1PCFGbits.PCFG10=1;
//    AD1PCFGbits.PCFG11=1;
//    AD1PCFGbits.PCFG14=1;
//
//    TRISBbits.TRISB8=0; // need B8 (the !CS line) to be an output
//
//}
//
//unsigned int SPItransfer(unsigned int dataOUT)
//{
//    	IFS1bits.SPI4RXIF=0; //	clear the interrupt flag
//	SPI4BUF=dataOUT;	// loads the transmit buffer with new data
//	while(!IFS1bits.SPI4RXIF); // waits for all the data to get shifted out by polling the interrupt flag
//        unsigned int newData=SPI4BUF; // get the new data and clear the buffer
//	return newData; // return the new data
//}
//
//void I2C_init(void) {
//
//    //Turn Off
//    I2C5CONbits.ON = 0;
//    printf("init");
//    //Set BRG
//    I2C5BRG = 0x02C;
//
//    // Disable JTAG
//    DDPCONbits.JTAGEN = 0;
//
//    // Set to digital
//    AD1PCFGbits.PCFG8 = 1;
//    AD1PCFGbits.PCFG10 = 1;
//    AD1PCFGbits.PCFG11 = 1;
//    AD1PCFGbits.PCFG14 = 1;
//
//    // Turn On
//    I2C5CONbits.ON = 1;
//
//}
//
//void start(void) {
//
//    I2C5CONbits.SEN=1; //Set Start Enable
//    while(!IFS1bits.I2C5MIF); //Wait for IF to signal start complete
//    IFS1bits.I2C5MIF = 0; //Reset IF
//
//}
//
//void stop(void) {
//
//    I2C5CONbits.PEN=1; //Set Stop Enable
//    while(!IFS1bits.I2C5MIF); //Wait for IF to signal stop complete
//    IFS1bits.I2C5MIF = 0; //Reset IF
//
//}
//
//void restart(void) {
//
//    I2C5CONbits.RSEN = 1; //Set Restart Enable
//    while(!IFS1bits.I2C5MIF); //Wait for IF to signal restart complete
//    IFS1bits.I2C5MIF = 0; //Reset IF
//
//}
//
//char I2C_send(char data) {
//
//    I2C5TRN = data; //Add data to be sent to transfer buffer
//    while(!IFS1bits.I2C5MIF); //Wait for IF to signal transfer complete
//    IFS1bits.I2C5MIF = 0; //Reset IF
//    return I2C5STATbits.ACKSTAT; //Return ACK from slave
//
//}
//
//char I2C_write(char data) {
//
//    start();
//    int ack = I2C_send(0xA0); //Send Control Byte (write)
//    //While loop makes sure EEPROM acks
//    while(ack) {
//        restart();
//        ack = I2C_send(0xA0);
//    }
//    I2C_send(0xFF); //Send 1st part of address
//    I2C_send(0xFF); //Send 2nd part of address
//    I2C_send(data); //Send data to be written
//    stop();
//
//}
//
//char I2C_receive(char ack) {
//
//    I2C5CONbits.RCEN = 1; //Set Receive Enable
//    while(!IFS1bits.I2C5MIF); //Wait for IF to signal Receive Enable complete
//    IFS1bits.I2C5MIF = 0; //Reset IF
//    char data = I2C5RCV; //Save data from buffer
//
//    I2C5CONbits.ACKDT = ack;
//    I2C5CONbits.ACKEN = 1; //Enable Master Ack
//
//    while(!IFS1bits.I2C5MIF); //Wait for IF to signal Master Ack Enable complete
//    IFS1bits.I2C5MIF = 0; //Reset IF
//    return data;
//
//}
//
//char I2C_read(void) {
//
//    start();
//    int ack = I2C_send(0xA0); //Send Control Byte (write)
//    //While loop makes sure EEPROM acks
//    while(ack) {
//        restart();
//        ack = I2C_send(0xA0);
//    }
//
//    I2C_send(0xFF); //Send 1st part of address
//    I2C_send(0xFF); //Send 2nd part of address
//    restart();
//    I2C_send(0xA1); //Send control byte (read)
//    char data = I2C_receive(1);
//    stop();
//
//    return data;
//}
//
//
//#endif	/* EEPROM_H */
//
